"Host Module"
import socket
from netconfpkg.NCAliasList import AliasList
from netconfpkg.NC_functions import testHostname

from netconfpkg import Host_base

class Host(Host_base):
    HostID = None

    def __init__(self, list = None, parent = None):
        Host_base.__init__(self, list, parent)
        # special store for the original comment
        self.Comment = None
        # special store for the original line
        self.origLine = None
        self.IP = None
        self.Hostname = None
        self.AliasList = AliasList()
 
    def createAliasList(self):
        if not self.AliasList:
            self.AliasList = AliasList()
        return self.AliasList

    def testIP(self):
        try:
            socket.inet_pton(socket.AF_INET, self.IP) 
        except socket.error:
            try:
                socket.inet_pton(socket.AF_INET6, self.IP) 
            except socket.error:
                return False
        return True
    
    def testHostname(self):
        return testHostname(self.Hostname) 
            
    def test(self):
        if not self.testIP():
            raise ValueError("IP")
        if not self.testHostname():
            raise ValueError("Hostname")
        if self.AliasList and not self.AliasList.test(): 
            raise ValueError("Alias")
